@echo off
chcp 65001
setlocal EnableDelayedExpansion
cd /d %~dp0

net.exe session 1>NUL 2>NUL && (
    goto as_admin
) || (
    goto not_admin
)

:as_admin
set versionPath=%cd%
cd ..
set rootPath=%cd%
::读取配置
set appName="xxxxx"
set file99=%rootPath%\config.txt
if exist %file99% (
    for /f "tokens=*" %%a in (%file99%) do (
	    set var=%%a
    
	    if "!var:~0,16!"=="applicationName:" (
	    	set appName=!var:~16,-1!!var:~-1,1!
	    )
    )
    set appName=!appName!
)
if not exist %rootPath%\%appName%.master (
    echo 只有master主干，才能建立新版本
    goto end
)

del /s /q %rootPath%\%appName%.branch.v*

::读取版本配置文件
cd /d %versionPath%
if not exist version.txt echo 1.0.0.20000101>version.txt
set configVersion=version.txt
for /f "tokens=1,2,3 delims=." %%a IN (%configVersion%)  Do (
     set tag1=%%a
     set tag2=%%b
     set tag3=%%c
)
set oldVersion=%tag1%.%tag2%.%tag3%

::提交数据，并打包为节点
set verPath=%cd%
cd ..
set rootPath=%cd%
cd /d %rootPath%
set tagName=%oldVersion%_%date:~0,4%%date:~5,2%%date:~8,2%%time:~0,2%%time:~3,2%%time:~6,2%
git tag -a %tagName% -m 建立节点
git push origin %tagName%

set /a tag3=1+%tag3%
set newVersion=%tag1%.%tag2%.%tag3%

::替换
set d=%date: =0%
set t=%time: =0%

cd /d %verPath%
set productname=%newVersion%.%d:~2,2%%d:~5,2%%d:~8,2%%t:~0,2%%t:~3,2%%t:~6,2%
echo %productname%
echo %productname%> version.txt
del /q *.panda
echo .>%newVersion%.panda

cd ..
del /q *.panda
echo .>%newVersion%.panda

echo 执行成功，生成 v%oldVersion%
goto end

:not_admin
echo not as admin

:end
ping 127.0.0.1 -n 10 >nul
exit

